/*


;                  ---------
;               5V |1     8| 0V
;         BUZZ GP5 |2     7| GP0 -> RED
;    PED.GREEN GP4 |3     6| GP1 -> YELLOW
;      PED.RED GP3 |4     5| GP2 -> GREEN
;                  ---------

*/

#include "12F629.H" 

//--- PORT DEFINITIONS ---------------------------------------------------
//               76543210
#define  TrisA 0b00000000                
//               ||||||||
//               |||||||RED
//               ||||||YELLOW
//               |||||GREEN
//               ||||PED.RED
//               |||PED.GREEN
//               ||BUZZ
//               |---
//               ---

#pragma  bit RED       @ PORTA.0   
#pragma  bit YELLOW    @ PORTA.1   
#pragma  bit GREEN     @ PORTA.2   
#pragma  bit PED_GREEN @ PORTA.4   
#pragma  bit PED_RED   @ PORTA.3   
#pragma  bit BUZZ      @ PORTA.5   

typedef unsigned char byte;
typedef unsigned long int LONG;
typedef bit BOOL;

char GetOsccal();							// Defined at end of file

#define NO_MCLR     &= ~0x80
#define CP_off      |= 0x2180
#pragma config  BODEN=off, NO_MCLR, PWRTE=on, FOSC=4, WDTE=off, CP_off

void Delay100us (unsigned char aTs) // pause for aTs*100 us;
{ // 4+x*3 us = 4+3*32=100 us;
 do  {
     char i = 33;            /* 2 IS */
     do ; while ( --i > 0);  /* 26 * 3 - 1 = 77 IS */
 } while ( --aTs > 0);         /* 3 IS */
}

void DelayMs (unsigned char aTs) // pause for aTs*1 ms;
{
 for (; aTs > 0; aTs--) {
   clrwdt();
   Delay100us (10);
 }
}

void Delay10ms (byte aTs) // pause for aTs*10 ms;
{
 for (; aTs > 0; aTs--) {
   Delay100us (100);
 }
}


void main()
{
  W = GetOsccal();						// Set built-in oscillator calibration
  OSCCAL = W;

    GIE = 0;                               
    GPIO = 0;                   //  Start with Everything Low
//    ANSEL = 0;                  //  Turn off ADC
    TRISIO= TrisA;                  //  All of GPIO are Outputs
    CMCON = 0b.0000.0111; // comparator is turned off;
    OPTION = 0;         

  while (1) {

  RED=1;     
  PED_GREEN=1;
  Delay10ms(200);
  Delay10ms(200);
  RED=0;
  PED_GREEN=0;
  PED_RED=1;
  Delay10ms(20);
  RED=1;
  Delay10ms(100);
  RED=0;

  GREEN=1;
  Delay10ms(200);
  Delay10ms(200);
  Delay10ms(200);
  Delay10ms(200);
  GREEN=0;

  YELLOW=1;
  Delay10ms(200);
  YELLOW=0;

  }
}

#pragma origin 0x3FF
// This is a dummy - actual procedure is preset in chip and will override
// A change of 1 causes about 1% change in frequency
char GetOsccal() {return 0x0;}

